<template>
  <header>
    <v-container v-if="!user">
      <v-layout row wrap justify-center>
        <v-form @submit.prevent="login()">
          <v-text-field v-model="username" label="Email" />
          <v-text-field v-model="password" label="Password" type="password" />
          <v-btn type="submit">Connexion</v-btn>
          <v-btn color="#616161" class="white--text">Inscription</v-btn>
        </v-form>
      </v-layout>
    </v-container>

    <v-container v-if="user">
      <v-layout row wrap justify-center>
        <div>
          <p>Hello {{user}}</p>
          <v-btn @click="logout()">Logout</v-btn>
        </div>
      </v-layout>
    </v-container>
  </header>
</template>

<script>
export default {
  data() {
    return {
      username: "",
      password: ""
    };
  },
  computed: {
    /**
     * On assigne à notre component une valeur qui
     * vient directement du store en passant
     * par une computed property
     */
    user() {
      return this.$store.state.user;
    }
  },
  methods: {
    login() {
      //On déclenche l'action du store qui permettra de se connecter
      //(on ne peut dispatch que les noms de méthodes existant dans les actions du store)
      this.$store.dispatch("login", {
        username: this.username,
        password: this.password
      });
    },
    logout() {
      //on déclenche une action du store pour se déconnecter
      this.$store.dispatch("logout");
    }
  }
};
</script>

<style>
</style>
